Difference between revisions of "Python scripting tutorial/ru"

From FreeCAD Documentation
Jump to navigation Jump to search
(Created page with "Модуль Draft добавляет двумерные параметрические типы объектов (которые являются объе...")
 
(59 intermediate revisions by 2 users not shown)
Line 1: Line 1:
 
<languages/>
 
<languages/>
  
{{Docnav
+
{{Docnav/ru
|[[Introduction_to_Python|Introduction to Python]]
+
|[[Introduction_to_Python/ru|Introduction to Python]]
|[[FreeCAD_Scripting_Basics|FreeCAD Scripting Basics]]
+
|[[FreeCAD_Scripting_Basics/ru|FreeCAD Scripting Basics]]
 
}}
 
}}
  
 
{{TOCright}}
 
{{TOCright}}
  
==Introduction==
+
==Введение==
  
<div class="mw-translate-fuzzy">
+
[https://ru.wikipedia.org/wiki/Python Python] - это язык программирования, относительно простой в изучении и понимании. Он является многоплатформенным  языком с открытым исходным кодом и может использоваться в разных целях: от программирования простых скриптов до очень сложных программ. Но он наиболее распространен как язык сценариев, внедряемых в другие приложения. Так он используется и внутри FreeCAD. Из [[Python_console/ru|консоли Python]] или с помощью собственных скриптов вы можете управлять FreeCAD, заставляя его выполнять очень сложные операции.
[http://en.wikipedia.org/wiki/Python_%28programming_language%29 Python] - это язык программирования, очень простой в использовании и изучении. Он является многоплатформенным  языком с открытым исходным кодом и может использоваться для в разных областях - от программирования простых скриптов до очень сложных программ. Но он наиболее распространен как язык сценариев, из-за легкости внедрения в другие приложения. Именно так он используется внутри FreeCAD. Из python  консоли или с помощью собственных скриптов вы можете управлять FreeCAD, заставляя его выполнять очень сложные действия, для которых еще нет GUI (графического пользовательского интерфейса)инструментов.
 
</div>
 
  
<div class="mw-translate-fuzzy">
+
Например, из сценария Python вы можете:
Например, из python сценария вы можете:
+
* Создать новые объекты.
* создать новые объекты
+
* Изменить существующие объекты.
* изменить существующие объекты
+
* Изменить трехмерное представление этих объектов.
* изменить трехмерное представление этих объектов
+
* Изменить интерфейс FreeCAD.
* изменить интерфейс FreeCAD
 
</div>
 
  
<div class="mw-translate-fuzzy">
+
Существует несколько способов использования Python в FreeCAD:
Существует несколько способов использования python в FreeCAD:
+
* Из [[FreeCAD Scripting Basics/ru|Интерпретатора Python в FreeCAD]], где вы можете запускать простые команды, симулируя интерфейс командной строки
* Из [[FreeCAD Scripting Basics | Интерпретатора python в FreeCAD]], где вы можете запускать простые команды, симулируя интерфейс командной строки
+
* Из [[macros/ru|макросов]], которые являются удобным способом быстрого добавления недостающего функционала в интерфейс FreeCAD
* Из [[macros|макросов]], которые являются удобным способом быстрого добавления недостающего функционала в интерфейс FreeCAD
+
* Из внешних скриптов, которые можно использовать для создания довольно сложных решений, даже [[Workbenches/ru|верстаков]].
* Из внешних скриптов, которые можно использовать для программирования более сложных вещей, таких как [[Workbenches|Верстаки]].
 
</div>
 
  
<div class="mw-translate-fuzzy">
+
В этом руководстве мы рассмотрим несколько базовых примеров, которые помогут вам начать работу. В этой вики также имеется гораздо больше [[Power users hub/ru|документации по Python сценариям]]. Если вы абсолютный новичок в Python и хотите понять, как это работает, у нас есть базовый курс [[introduction to Python/ru|Введение в Python]].
В этом руководстве мы рассмотрим несколько простых примеров, которые помогут вам начать работу. В этой вики также имеется гораздо больше [[Power users hub | документации по python сценариям]]. Если вы абсолютный новичок в python и хотите понять, как это работает, у нас есть базовый курс [[introduction to Python|Введение в Python]].
 
</div>
 
  
<div class="mw-translate-fuzzy">
+
Перед написанием сценариев Python, перейдите в окно {{MenuCommand|Правка → Настройки → Основные → Просмотр отчёта}} и проверьте, отмечены ли два пункта:
"'Важно!'" Перед написанием Python сценариев, перейдите в окно {{MenuCommand | Edit-> Prefences-> General-> Output}} и проверьте 2 пункта:
+
* {{MenuCommand|Перенаправить внутренний вывод Python в отчет}}.
* Перенаправить внутренний вывод Python в отчет
+
* {{MenuCommand|Перенаправить внутренние ошибки Python в отчет}}.
* Перенаправить внутренние ошибки Python в отчет
+
Затем перейдите в {{MenuCommand|Вид → Панели}} и отметьте:
Затем перейдите в {{MenuCommand | View-> Panels}} и проверьте:
+
* {{MenuCommand|Отчет}}.
* Отчет
 
Это сэкономит вам много нервов!
 
</div>
 
  
<div class="mw-translate-fuzzy">
+
==Написание кода Python==
== Написание python кода ==
 
Существует два простых способа написания Python кода в FreeCAD: в python  консоли (меню «Вид-> Панели -> Консоль Python») или из редактора макросов (Инструменты -> Макросы). В консоли вы последовательно пишете python команды, которые выполняются при нажатии return. Макросы могут содержать более сложный много-строчный скрипт, который выполняется во время запуска макроса.
 
</div>
 
  
There are two ways to write Python code in FreeCAD. In the [[Python console|Python console]] (select {{MenuCommand|View Panels → Python console}} from the menu) or in the [[Std_DlgMacroExecute|Macro editor]] (select {{MenuCommand|Macro Macros...}} from the menu). In the console you write Python commands one by one, executing them by pressing {{KEY|Enter}}, while macros can contain more complex code made up of several lines, executed only when the macro is executed.
+
Существует два простых способа написания кода Python в FreeCAD: в [[Python console/ru|консоли Python]] (выберите в меню {{MenuCommand|Вид Панели Консоль Python}}) или из [[Std_DlgMacroExecute/ru|редактора макросов]] (выберите в меню {{MenuCommand|Инструменты Макросы}}). В консоли вы последовательно пишете python команды, которые выполняются при нажатии {{KEY|Enter}}. Макросы могут содержать более сложный многострочный код, который выполняется только во время запуска макроса.
  
 
[[Image:Screenshot_pythoninterpreter.jpg]]
 
[[Image:Screenshot_pythoninterpreter.jpg]]
<div class="mw-translate-fuzzy">
+
{{Caption|Консоль Python в FreeCAD}}
[[Image:Screenshot_pythoninterpreter.jpg|center|frame|The FreeCAD python console]]
 
</div>
 
  
<div class="mw-translate-fuzzy">
+
В этом руководстве можно использовать оба метода. Можно копировать/вставлять по одной строчке в консоли Python и нажимать {{KEY|Enter}}, или копировать/вставлять весь код в новое окно макроса.
В этом руководстве описаны оба метода: либо путем копирования / вставки по одной строчке в python консоли и нажатия {{KEY | Return}} в конце строки, либо путем копирования / вставки всего кода в новое окно макроса.
+
 
</div>
+
[[#top|top]]
  
<div class="mw-translate-fuzzy">
 
 
== Изучение FreeCAD ==
 
== Изучение FreeCAD ==
Начнем с создания нового пустого документа:
 
</div>
 
  
Let's start by creating a new empty document:
+
Начнём с создания нового пустого документа:
  
 
{{Code|code=
 
{{Code|code=
Line 69: Line 50:
 
}}
 
}}
  
<div class="mw-translate-fuzzy">
+
Если Вы вводите это в консоли Python FreeCADа, то заметите, что как только Вы ввели {{incode|FreeCAD.}} (слово FreeCAD с последующей точкой), появится окно, позволяющее быстро автозаполнить продолжение строки. Даже лучше, каждый ввод в списке автодополнения содержит подсказку. Это облегчает раскрытие имеющейся функциональности. Перед выбором {{incode|newDocument}}, взгляните на другие доступные опции.
Если Вы вводите это в python консоли FreeCADа, то заметите, что как только Вы ввели "FreeCAD." (слово FreeCAD с последующей точкой), появится окно, позволяющее быстро автозаполнить продолжение строки. Даже лучше, каждый ввод в списке автодополнения содержит подсказку. Это облегчает раскрытие имеющейся функциональности. Перед выбором "newDocument", взгляните на другие доступные опции.
 
</div>
 
  
 
[[Image:Screenshot_classbrowser.jpg]]
 
[[Image:Screenshot_classbrowser.jpg]]
<div class="mw-translate-fuzzy">
+
{{Caption|Механизм автозаполнения python консоли FreeCAD}}
[[Image:Screenshot_classbrowser.jpg|center|frame|Механизм автозаполнения python консоли FreeCAD]]
 
</div>
 
  
<div class="mw-translate-fuzzy">
+
Теперь наш новый документ будет создан. Это похоже на нажатие кнопки {{Button|[[Image:Std_New.svg|16px]] [[Std_New/ru|Std New]]}} на панели инструментов. Фактически, большинство кнопок в FreeCAD ничего не делают, кроме выполнения одной или нескольких строк кода Python. Даже лучше, вы можете установить параметр в {{MenuCommand|Правка → Настройки → Общее → Макрос}}, чтобы {{MenuCommand|показать команды сценария в консоли Python}}. Это будет выводить в консоль весь код Python, который выполняется при нажатии кнопок. Очень полезно, чтобы узнать, как воспроизводить действия в Python.
Теперь наш новый документ будет создан. Это похоже на нажатие кнопки «новый документ» на панели инструментов. Фактически, большинство кнопок в FreeCAD ничего не делают, кроме выполнения строки или двух python кода. Еще лучше, вы можете установить параметр в {{MenuCommand | Edit-> Preferences-> General-> Macro}}, чтобы «показать команды сценария в консоли python». Это будет выводить в консоль весь python код, который выполняется при нажатии кнопок. Очень полезно узнать, как воспроизводить действия в python.
 
</div>
 
  
<div class="mw-translate-fuzzy">
+
Теперь вернёмся назад в документ и посмотрим, что мы можем с ним сделать:
Теперь вернёмся назад в документ. Посмотрим, что мы можем с ним сделать:
 
</div>
 
  
 
{{Code|code=
 
{{Code|code=
Line 93: Line 66:
  
 
{{Code|code=
 
{{Code|code=
box = doc.addObject("Part::Box","myBox")
+
box = doc.addObject("Part::Box", "myBox")
 
}}
 
}}
  
Line 124: Line 97:
 
Если вы выберете куб с помощью мыши, вы увидите, что [[Property_editor/ru|Property editor]] на вкладке {{MenuCommand|Данные}} появится параметр {{PropertyData|Height}}. Все свойства объекта FreeCAD, которые появляются там (а также на вкладке {{MenuCommand|Вид}}, подробнее об этом позже), напрямую доступны также для Python по их именам, аналогично параметру {{PropertyData|Height}}. Попробуйте изменить другие размеры окна.
 
Если вы выберете куб с помощью мыши, вы увидите, что [[Property_editor/ru|Property editor]] на вкладке {{MenuCommand|Данные}} появится параметр {{PropertyData|Height}}. Все свойства объекта FreeCAD, которые появляются там (а также на вкладке {{MenuCommand|Вид}}, подробнее об этом позже), напрямую доступны также для Python по их именам, аналогично параметру {{PropertyData|Height}}. Попробуйте изменить другие размеры окна.
  
==Vectors and Placements==
+
[[#top|top]]
[http://en.wikipedia.org/wiki/Euclidean_vector Vectors] are a very fundamental concept in any 3D application. A vector is a list of 3 numbers (x, y and z), describing a point or position in 3D space. Many things can be done with vectors, such as additions, subtractions, projections and [http://en.wikipedia.org/wiki/Vector_space much more]. In FreeCAD vectors work like this:
+
 
 +
==Вектора и размещение==
 +
 
 +
[https://ru.wikipedia.org/wiki/Вектор_(геометрия) Вектора] это самая основная концепция в любом трёхмерном приложении. Вектор это список трёх чисел (x, y и z), описывающих точку или позицию в трёхмерном пространстве. С векторами делаются многие вещи, такие как сложение, вычитание, проекции и [https://ru.wikipedia.org/wiki/Линейное_пространство многое другое]. В FreeCAD вектора работают примерно так:
  
 
{{Code|code=
 
{{Code|code=
myvec = FreeCAD.Vector(2,0,0)
+
myvec = FreeCAD.Vector(2, 0, 0)
 
myvec.x
 
myvec.x
 
myvec.y
 
myvec.y
othervec = FreeCAD.Vector(0,3,0)
+
othervec = FreeCAD.Vector(0, 3, 0)
 
sumvec = myvec.add(othervec)
 
sumvec = myvec.add(othervec)
 
}}
 
}}
  
Another common feature of FreeCAD objects is their [[Placement|placement]]. Each object has a {{PropertyData|Placement}} property, which contains the {{PropertyData|Base}} (position) and {{PropertyData|Rotation}} (orientation) of the object. It is easy to manipulate, for example to move our object:
+
Еще одно имеющееся у всех объектов FreeCAD свойство - это его [[Placement/ru|размещение]]. Каждый объект имеет свойство {{PropertyData/ru|Placement}}, которое содержит {{PropertyData|Base}} (положение) и {{PropertyData|Rotation}} (ориентация) объекта. Это легко манипулировать, например, чтобы переместить наш объект:
  
 
{{Code|code=
 
{{Code|code=
Line 146: Line 122:
 
}}
 
}}
  
Now you must understand a couple of important concepts before we get further.
+
Теперь вы должны понять пару важных понятий, прежде чем мы продолжим.
 +
 
 +
[[#top|top]]
  
==App and Gui==
+
==App и Gui==
  
FreeCAD has been designed so that it can also be used without its user interface, as a command-line application. Almost every object in FreeCAD therefore consists of two parts: an {{incode|Object}}, its "geometry" component, and a {{incode|ViewObject}}, its "visual" component. When you work in command-line mode, the geometry part is present, but the visual part is disabled.
+
FreeCAD был разработан так, чтобы его можно было использовать без пользовательского интерфейса, как приложение командной строки. Поэтому почти каждый объект в FreeCAD состоит из двух частей: {{incode|Object}}, компонент "геометрии", и {{incode|ViewObject}}, его "визуальная" компонента. При работе в режиме командной строки геометрическая часть имеется, но визуальная часть отключена.
  
To illustrate the concept let's look at our cube object. The geometric properties of the cube, such as its dimensions, position, etc. are stored in the {{incode|Object}}. While its visual properties, such as its color, line thickness, etc. are stored in the {{incode|ViewObject}}. This corresponds to the '''Data''' and '''View''' tabs in the [[Property_editor|Property editor]]. The view object of an object is accessed like this:
+
Для иллюстрации концепции давайте посмотрим на наш объект куба. Геометрические свойства куба, такие как его размеры, положение и т.д., хранятся в {{incode|Object}}. А его визуальные свойства, такие как цвет, толщина линий и т.д., хранятся в {{incode|ViewObject}}. Это соответствует вкладкам «Данные» и «Вид» в [[Property_editor/ru|Редакторе свойств]]. Доступ к объекту вида осуществляется следующим образом:
  
 
{{Code|code=
 
{{Code|code=
 
vo = box.ViewObject
 
vo = box.ViewObject
 
}}
 
}}
Now you can also change the properties on the '''View''' tab:
+
Теперь вы также можете изменить свойства на вкладке «Вид»:
  
 
{{Code|code=
 
{{Code|code=
Line 165: Line 143:
 
}}
 
}}
  
When you start FreeCAD, the Python console already loads two base modules: {{incode|FreeCAD}} and {{incode|FreeCADGui}} (which can also be accessed by their shortcuts {{incode|App}} and {{incode|Gui}}). They contain all kinds of generic functionality to work with documents and their objects. To illustrate our concept, see that both {{incode|FreeCAD}} and {{incode|FreeCADGui}} contain an {{incode|ActiveDocument}} attribute, which is the currently opened document. {{incode|FreeCAD.ActiveDocument}} and {{incode|FreeCADGui.ActiveDocument}} are not the same object however. They are the two components of a FreeCAD document, and they contain different attributes and methods. For example, {{incode|FreeCADGui.ActiveDocument}} contains {{incode|ActiveView}}, which is the currently opened [[3D_view|3D view]].
+
Когда вы запускаете FreeCAD, консоль Python уже загрузила два базовых модуля: {{incode|FreeCAD}} и {{incode|FreeCADGui}}(которые также могут быть доступны по их ярлыкам {{incode|App}} и {{incode|Gui}}). Они содержат все виды общих функций для работы с документами и их объектами. Для иллюстрации нашей концепции, посмотрите, что и {{incode|FreeCAD}}, и {{incode|FreeCADGui}} содержат атрибут {{incode|ActiveDocument}}, который является текущим открытым документом. Однако {{incode|FreeCAD.ActiveDocument}} и {{incode|FreeCADGui.ActiveDocument}} это не один и тот же объект. Это два компонента документа FreeCAD, и содержат разные атрибуты и методы. Например, {{incode|FreeCADGui.ActiveDocument}} содержит {{incode|ActiveView}}, это текущий открытый [[3D_view/ru|трёхмерный вид]].
  
==Modules==
+
[[#top|top]]
  
The true power of FreeCAD lies in its faithful modules. The FreeCAD base application is more or less an empty container. Without its modules it can do little more than create new, empty documents. Each module not only adds new workbenches to the interface, but also new Python commands and new object types. As a result several different, and even totally incompatible, object types can coexist in the same document. The most important modules in FreeCAD that we'll look at in this tutorial are: [[Part_Module|Part]], [[Mesh_Module|Mesh]], [[Sketcher_Workbench|Sketcher]] and [[Draft_Module|Draft]].
+
==Модули==
  
[[Sketcher_Workbench|Sketcher]] and [[Draft_Module|Draft]] both use the [[Part_Module|Part]] module to create and handle their geometry. While [[Mesh_Module|Mesh]] is totally independent, and handles its own objects. More about that below.
+
Истинная сила FreeCAD заключается в его верных модулях. Базовое приложение FreeCAD - это более или менее пустой контейнер. Без своих модулей он может сделать немного больше, чем создавать новые, пустые документы. Каждый модуль добавляет к интерфейсу не только новые верстаки, но и новые команды Python и новые типы объектов. В результате несколько разных и даже полностью несовместимых типов объектов могут сосуществовать в одном документе. Наиболее важные модули в FreeCAD, которые мы рассмотрим в этом руководстве, это: [[Part_Module/ru|Part]], [[Mesh_Module/ru|Mesh]], [[Sketcher_Workbench/ru|Sketcher]] и [[Draft_Module/ru|Draft]].
  
You can check all the available base object types for the current document like this:
+
Модули [[Sketcher_Workbench/ru|Sketcher]] и [[Draft_Module/ru|Draft]] используют модуль [[Part_Module/ru|Part]] для создания и поддержки их геометрии, в то время как модуль [[Mesh_Module/ru|Mesh]] полностью независим и поддерживает собственные объекты. Подробнее об этом ниже.
 +
 
 +
Вы можете проверить все доступные типы базовых объектов для текущего документа следующим образом:
  
 
{{Code|code=
 
{{Code|code=
Line 179: Line 159:
 
}}
 
}}
  
The different FreeCAD modules are not automatically loaded in the Python console. This is to avoid having a very slow startup. Modules are loaded only when you need them. So, for example, to explore what's inside the Part module:
+
Различные модули FreeCAD не загружаются в консоль Python автоматически. Это нужно для того, чтобы избежать замедленного запуска. Модули загружаются только тогда, когда они вам нужны. Поэтому для исследования того, что, например, находится внутри модуля Part:
  
 
{{Code|code=
 
{{Code|code=
Line 186: Line 166:
 
}}
 
}}
  
But we'll talk more about the Part module below.
+
Но мы поговорим подробнее о модуле Part ниже.
 +
 
 +
[[#top|top]]
  
 
==Mesh==
 
==Mesh==
  
[http://en.wikipedia.org/wiki/Polygon_mesh Meshes] are a very simple kind of 3D object, used for example by [http://en.wikipedia.org/wiki/SketchUp Sketchup], [http://en.wikipedia.org/wiki/Blender_%28software%29 Blender] and [http://en.wikipedia.org/wiki/Autodesk_3ds_Max 3D studio Max]. They are composed of 3 elements: points (also called vertices), lines (also called edges) and faces. In many applications, FreeCAD included, faces can have only 3 vertices. Of course, nothing prevents you from having a bigger face made up of several coplanar triangles.
+
[https://ru.wikipedia.org/wiki/Полигональная_сетка Сетки (meshes)] это весьма простой тип трёхмерных объектов, используемых, например, в [https://ru.wikipedia.org/wiki/SketchUp Sketchup], [https://ru.wikipedia.org/wiki/Blender Blender] и [https://ru.wikipedia.org/wiki/Autodesk_3ds_Max 3D Studio Max]. Они состоят из 3 элементов: точек (также называемых вершинами), линий (также называемых ребрами) и граней. Во многих приложениях, включая FreeCAD, грани могут иметь только 3 вершины. Разумеется, ничто не мешает использовать более крупные грани, состоящее из нескольких копланарных треугольников.
  
Meshes are simple, but because they are simple you can easily have millions of them in a single document. However, in FreeCAD they have less use and are mostly there so you can import objects in mesh formats ({{FileName|.stl}}, {{FileName|.obj}}) from other applications. The Mesh module was also used extensively as the main test module in the first month of FreeCAD's life.
+
Сетки просты, и благодаря простоте их можно иметь миллионами в одном документе. Однако в FreeCAD они имеют меньшее использование, и в основном там, где надо импортировать объекты в форматах сетки ({{FileName|.stl}}, {{FileName|.obj}}) из других приложений. Модуль Mesh так же широко использовался в качестве основного тестового модуля в первые месяцы жизни FreeCAD.
  
Mesh objects and FreeCAD objects are different things. You can see the FreeCAD object as a container for a Mesh object (and as we'll see below, for Part objects also). So in order to add a mesh object to FreeCAD, we must first create a FreeCAD object and a Mesh object, then add the Mesh object to the FreeCAD object:
+
Сеточные объекты и объекты FreeCAD - это разные вещи. Вы можете видеть объект FreeCAD как контейнер для объекта Mesh (и, как мы увидим ниже, также для объектов Part). Поэтому чтобы добавить объект сетки в FreeCAD, мы должны сначала создать объект FreeCAD и объект Mesh, а затем добавить объект Mesh в объект FreeCAD:
  
 
{{Code|code=
 
{{Code|code=
Line 202: Line 184:
 
mymesh.Points
 
mymesh.Points
 
   
 
   
meshobj = doc.addObject("Mesh::Feature","MyMesh")
+
meshobj = doc.addObject("Mesh::Feature", "MyMesh")
 
meshobj.Mesh = mymesh
 
meshobj.Mesh = mymesh
 
doc.recompute()
 
doc.recompute()
 
}}
 
}}
  
This is a standard example that uses the {{incode|createSphere()}} method to create a sphere, but you can also create custom meshes from scratch by defining their vertices and faces.
+
Это стандартный пример, который использует метод {{incode|createSphere()}} для создания сферы, но вы также можете создавать собственные сетки с нуля, определяя их вершины и грани.
  
[[Mesh Scripting|Read more about mesh scripting...]]
+
[[Mesh Scripting/ru|Дальнейшее чтение о скриптах обработки сеток...]]
 +
 
 +
[[#top|top]]
  
 
==Part==
 
==Part==
  
The [[Part Module|Part Module]] is the most powerful module in the whole of FreeCAD. It allows you to create and manipulate [http://en.wikipedia.org/wiki/Boundary_representation BRep] objects. BRep stands for "Boundary Representation". A BRep object is defined by surfaces that enclose and define an inner volume. Unlike meshes, BRep objects can have a wide variety of components from planar faces to very complex NURBS surfaces.
+
[[Part Module/ru|Модуль Part]] это самый мощный модуль во всём FreeCAD. Он позволяет создавать и управлять объектами [https://ru.wikipedia.org/wiki/Граничное_представление граничного представления (BRep)]. Объект BRep (Boundary Representation) определяется поверхностями, которые ограничивают и определяют внутренний объем. В отличие от сеток, объекты BRep могут иметь широкий спектр компонентов, от плоских граней до очень сложных поверхностей NURBS.
  
The Part module is based on the powerful [http://en.wikipedia.org/wiki/Open_CASCADE_Technology OpenCasCade] library, which allows a wide range of complex operations to be performed on those objects, such as boolean operations, filleting, lofts, etc.
+
Модуль Part основан на мощной библиотеке [https://ru.wikipedia.org/wiki/Open_CASCADE_Technology OpenCasCade], обеспечивающей широкий спектр сложных операций над этими объектами, таких как логические операции, филетирование, лофты и т. д.
  
The Part module works the same way as the Mesh module: You create a FreeCAD object, a Part object, then add the Part object to the FreeCAD object:
+
Модуль Part работает так же, как и модуль Mesh: вы создаете объект FreeCAD, объект Part, а затем добавляете объект Part к объекту FreeCAD:
  
 
{{Code|code=
 
{{Code|code=
Line 225: Line 209:
 
myshape.Area
 
myshape.Area
  
shapeobj = doc.addObject("Part::Feature","MyShape")
+
shapeobj = doc.addObject("Part::Feature", "MyShape")
 
shapeobj.Shape = myshape
 
shapeobj.Shape = myshape
 
doc.recompute()
 
doc.recompute()
 
}}
 
}}
  
The Part module (like the Mesh module) also has a shortcut that automatically creates a FreeCAD object and adds a shape to it, so you can shorten the last three lines to:
+
Модуль Part, как и модуль Mesh, имеет ярлык, который автоматически создает объект FreeCAD и добавляет к нему форму, поэтому вы можете сократить последние три строки до:
  
 
{{Code|code=
 
{{Code|code=
Line 236: Line 220:
 
}}
 
}}
  
By exploring the contents of myshape, you will notice many interesting subcomponents such as {{incode|Faces}}, {{incode|Edges}}, {{incode|Vertexes}}, {{incode|Solids}} and {{incode|Shells}}, and a wide range of geometry operations such as {{incode|cut}} (subtraction), {{incode|common}} (intersection) or {{incode|fuse}} (union). The [[Topological_data_scripting|Topological data scripting]] page explains all that in detail.
+
Исследуя содержимое myshape, вы заметите много интересных подкомпонентов, таких как {{incode|Faces}}, {{incode|Edges}}, {{incode|Vertexes}}, {{incode|Solids}} и {{incode|Shells}}, и широкий спектр геометрических операций, таких как {{incode|cut}} (вычитание), {{incode|common}} (пересечение) или {{incode|fuse}} (объединение). Страница [[Topological_data_scripting/ru|Топологические сценарии данных]] объясняет все это в деталях.
  
[[Topological_data_scripting|Read more about part scripting...]]
+
[[Topological_data_scripting/ru|Читать далее про обработку объектов Part в скриптах...]]
 +
 
 +
[[#top|top]]
  
 
==Draft==
 
==Draft==
  
FreeCAD features many more modules, such as [[Sketcher_Workbench|Sketcher]] and [[Draft_Module|Draft]], that also create Part objects. These modules add additional parameters to the objects created, or even implement a whole new way to handle the Part geometry in them. Our box example above is a perfect example of a parametric object. All you need to define the box is to specify the parameters height, width and length. Based on those, the object will automatically calculate its Part shape. FreeCAD allows you to [[Scripted_objects|create such objects in Python]].
+
FreeCAD включает в себя много других модулей, таких как [[Sketcher_Workbench/ru|Sketcher]] и [[Draft_Module/ru|Draft]], которые также создают объекты Part. Эти модули добавляют дополнительные параметры к созданным объектам или даже реализуют в них совершенно новый способ обработки геометрии Part. Наш приведенный выше пример куба является идеальным примером параметрического объекта. Все, что вам нужно, чтобы определить куб, это указать параметры высоты, ширины и длины. Исходя из этого, объект автоматически рассчитает свою форму Part. FreeCAD позволяет вам [[Scripted_objects/ru|создавать такие объекты в Python]].
  
The [[Draft Module|Draft Module]] adds 2D parametric object types (which are all Part objects) such as lines and circles, and also provides some generic functions that not only work on Draft objects, but on any Part object. To explore what is available, simply do:
+
[[Draft Module/ru|Модуль Draft]] добавляет двумерные параметрические типы объектов (которые являются объектами Part), такие как линии и круги, а также предоставляет некоторые общие функции, которые работают не только с объектами Draft, но и с любым объектом Part. Чтобы узнать, что доступно, просто сделайте:
  
 
{{Code|code=
 
{{Code|code=
 
import Draft
 
import Draft
rec = Draft.makeRectangle(5,2)
+
rec = Draft.makeRectangle(5, 2)
mvec = FreeCAD.Vector(4,4,0)
+
mvec = FreeCAD.Vector(4, 4, 0)
Draft.move(rec,mvec)
+
Draft.move(rec, mvec)
Draft.move(box,mvec)
+
Draft.move(box, mvec)
 
}}
 
}}
  
==Interface==
+
[[#top|top]]
  
The FreeCAD user interface is made with [http://en.wikipedia.org/wiki/Qt_%28framework%29 Qt], a powerful graphical interface system, responsible for drawing and handling all the controls, menus, toolbars and buttons around the [[3D_view|3D view]]. Qt provides a module, [[PySide]], which allows Python to access and modify Qt interfaces such as FreeCAD's. Let's try to fiddle with the Qt interface and produce a simple dialog:
+
==Интерфейс==
 +
 
 +
Пользовательский интерфейс FreeCAD сделан с помощью [https://ru.wikipedia.org/wiki/Qt Qt], мощной системs графического интерфейса, отвечающей за рисование и обработку всех элементов управления, меню, панелей инструментов и кнопок вокруг окна [[3D_view/ru|трёхмерного просмотра]]. В Qt есть модуль [[PySide/ru|PySide]], через который Python получает доступ к интерфейсам Qt, таким как у FreeCAD. Давайте попробуем поработать с интерфейсом Qt и создать простой диалог:
  
 
{{Code|code=
 
{{Code|code=
 
from PySide import QtGui
 
from PySide import QtGui
QtGui.QMessageBox.information(None,"Apollo program","Houston, we have a problem")
+
QtGui.QMessageBox.information(None, "Apollo program", "Houston, we have a problem")
 
}}
 
}}
  
Notice that the dialog that appears has the FreeCAD icon in its toolbar, meaning that Qt knows that the order has been issued from inside the FreeCAD application. It is possible to manipulate any part of the FreeCAD interface.
+
Обратите внимание, что в появившемся диалоговом окне на панели инструментов есть значок FreeCAD, означающий, что Qt знает, что вызов был отдан из приложения FreeCAD. Можно манипулировать любой частью интерфейса FreeCAD.
 +
 
 +
Qt - это очень мощная система интерфейса, позволяющая делать очень сложные вещи. Она так же имеет несколько простых в использовании инструментов, таких как Qt Designer, с помощью которых вы можете создавать графические диалоги, а затем добавлять их в интерфейс FreeCAD с помощью нескольких строк кода Python.
 +
 
 +
[[PySide/ru|Дальнейшее чтение о PySide здесь...]]
  
Qt is a very powerful interface system that allows you to do very complex things. It also has some easy-to-use tools such as the Qt Designer with which you can design dialogs graphically and then add them to the FreeCAD interface with a few lines of Python code.
+
[[#top|top]]
  
[[PySide|Read more about PySide here...]]
+
==Макросы==
  
==Macros==
+
Теперь, уже хорошо понимая основы, где мы будем хранить наши скрипты Python и как мы собираемся запускать их внутри FreeCAD? Для этого есть простой механизм, называемый [[Macros/ru|Макросы]]. Макросы - это скрипты Python, которые можно добавлять в панели инструментов и запускать кликом мыши. FreeCAD предоставляет простой текстовый редактор ({{MenuCommand|Макросы → Макрос... → Собрать}}), где вы можете написать или вставить сценарии. Как только скрипт готов, используйте {{MenuCommand|Инструменты → Настройка... → Макрос}} для определения ему кнопки, которую можно добавить на панели инструментов.
  
Now that you have a good understanding of the basics, where are we going to keep our Python scripts, and how are we going to launch them inside FreeCAD? There is an easy mechanism for that, called [[Macros|Macros]]. A macro is a Python script that can be added to a toolbar and launched via a mouse click. FreeCAD provides you with a simple text editor ({{MenuCommand|Macro → Macros... → Create}}) where you can write or paste scripts. Once the script is done, use {{MenuCommand|Tools → Customize... → Macros}} to define a button for it that can be added to toolbars.
+
Теперь вы готовы к более глубокому написанию сценариев FreeCAD. Так вперёд в [[Power_users_hub/ru|Центр опытных пользователей]]!
  
Now you are ready for more in-depth FreeCAD scripting. So head on to the [[Power_users_hub|Power users hub]]!
+
[[#top|top]]
  
{{Docnav
+
{{Docnav/ru
|[[Introduction_to_Python|Introduction to Python]]
+
|[[Introduction_to_Python/ru|Introduction to Python]]
|[[FreeCAD_Scripting_Basics|FreeCAD Scripting Basics]]
+
|[[FreeCAD_Scripting_Basics/ru|FreeCAD Scripting Basics]]
 
}}
 
}}
  
 
{{Powerdocnavi{{#translation:}}}}
 
{{Powerdocnavi{{#translation:}}}}
[[Category:Python_Code{{#translation:}}]]
+
[[Category:Developer Documentation{{#translation:}}]]
 +
[[Category:Python Code{{#translation:}}]]
 
{{clear}}
 
{{clear}}

Latest revision as of 19:36, 8 June 2020

Other languages:
Bahasa Indonesia • ‎Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎italiano • ‎polski • ‎português • ‎română • ‎čeština • ‎русский • ‎中文(中国大陆)‎ • ‎日本語

Введение

Python - это язык программирования, относительно простой в изучении и понимании. Он является многоплатформенным языком с открытым исходным кодом и может использоваться в разных целях: от программирования простых скриптов до очень сложных программ. Но он наиболее распространен как язык сценариев, внедряемых в другие приложения. Так он используется и внутри FreeCAD. Из консоли Python или с помощью собственных скриптов вы можете управлять FreeCAD, заставляя его выполнять очень сложные операции.

Например, из сценария Python вы можете:

  • Создать новые объекты.
  • Изменить существующие объекты.
  • Изменить трехмерное представление этих объектов.
  • Изменить интерфейс FreeCAD.

Существует несколько способов использования Python в FreeCAD:

  • Из Интерпретатора Python в FreeCAD, где вы можете запускать простые команды, симулируя интерфейс командной строки
  • Из макросов, которые являются удобным способом быстрого добавления недостающего функционала в интерфейс FreeCAD
  • Из внешних скриптов, которые можно использовать для создания довольно сложных решений, даже верстаков.

В этом руководстве мы рассмотрим несколько базовых примеров, которые помогут вам начать работу. В этой вики также имеется гораздо больше документации по Python сценариям. Если вы абсолютный новичок в Python и хотите понять, как это работает, у нас есть базовый курс Введение в Python.

Перед написанием сценариев Python, перейдите в окно Правка → Настройки → Основные → Просмотр отчёта и проверьте, отмечены ли два пункта:

  • Перенаправить внутренний вывод Python в отчет.
  • Перенаправить внутренние ошибки Python в отчет.

Затем перейдите в Вид → Панели и отметьте:

  • Отчет.

Написание кода Python

Существует два простых способа написания кода Python в FreeCAD: в консоли Python (выберите в меню Вид → Панели → Консоль Python) или из редактора макросов (выберите в меню Инструменты → Макросы). В консоли вы последовательно пишете python команды, которые выполняются при нажатии Enter. Макросы могут содержать более сложный многострочный код, который выполняется только во время запуска макроса.

Screenshot pythoninterpreter.jpg

Консоль Python в FreeCAD


В этом руководстве можно использовать оба метода. Можно копировать/вставлять по одной строчке в консоли Python и нажимать Enter, или копировать/вставлять весь код в новое окно макроса.

top

Изучение FreeCAD

Начнём с создания нового пустого документа:

doc = FreeCAD.newDocument()

Если Вы вводите это в консоли Python FreeCADа, то заметите, что как только Вы ввели FreeCAD. (слово FreeCAD с последующей точкой), появится окно, позволяющее быстро автозаполнить продолжение строки. Даже лучше, каждый ввод в списке автодополнения содержит подсказку. Это облегчает раскрытие имеющейся функциональности. Перед выбором newDocument, взгляните на другие доступные опции.

Screenshot classbrowser.jpg

Механизм автозаполнения python консоли FreeCAD


Теперь наш новый документ будет создан. Это похоже на нажатие кнопки Std New.svg Std New на панели инструментов. Фактически, большинство кнопок в FreeCAD ничего не делают, кроме выполнения одной или нескольких строк кода Python. Даже лучше, вы можете установить параметр в Правка → Настройки → Общее → Макрос, чтобы показать команды сценария в консоли Python. Это будет выводить в консоль весь код Python, который выполняется при нажатии кнопок. Очень полезно, чтобы узнать, как воспроизводить действия в Python.

Теперь вернёмся назад в документ и посмотрим, что мы можем с ним сделать:

doc.

Изучим доступные варианты. Обычно имена, начинающиеся с заглавной буквы, это атрибуты, они содержат значения, а имена с маленькой буквы являются функциями (называемые так же методами), они "что-то делают". Имена, начинающиеся с подчёркиваний, обычно используются для внутренних нужд модуля, и Вам не следует обращать на них внимание. Используем один из методов для добавления в документ нового объекта:

box = doc.addObject("Part::Box", "myBox")

Ничего не произошло. Почему? Потому что FreeCAD создан для больших проектов. Однажды он будет работать с сотнями сложных взаимосвязанных объектов. Возможно, что внесение небольшого изменения может иметь большое значение, вам может потребоваться пересчитать весь документ, что может занять много времени ... По этой причине почти никакая команда не обновляет сцену автоматически. Вы должны сделать это вручную:

doc.recompute()

Теперь наш куб появился в окне трёхмерного вида. Большинство кнопок панелей инструментов фактически делают две вещи: добавляют объект и выполняют пересчёт. Если Вы включите в настройках опцию "Показывать команды скриптов в консоли python" и попробуете добавить сферу с соответствующей кнопкой, Вы увидите две строки Python кода, выполняемые одна за другой.

Теперь рассмотрим содержимое нашего куба:

box.

Вы немедленно увидите несколько очень интересных вещей вроде этого:

box.Height

Это покажет текущую высоту нашего куба. Теперь попробуем её изменить:

box.Height = 5

Если вы выберете куб с помощью мыши, вы увидите, что Property editor на вкладке Данные появится параметр DataHeight. Все свойства объекта FreeCAD, которые появляются там (а также на вкладке Вид, подробнее об этом позже), напрямую доступны также для Python по их именам, аналогично параметру DataHeight. Попробуйте изменить другие размеры окна.

top

Вектора и размещение

Вектора это самая основная концепция в любом трёхмерном приложении. Вектор это список трёх чисел (x, y и z), описывающих точку или позицию в трёхмерном пространстве. С векторами делаются многие вещи, такие как сложение, вычитание, проекции и многое другое. В FreeCAD вектора работают примерно так:

myvec = FreeCAD.Vector(2, 0, 0)
myvec.x
myvec.y
othervec = FreeCAD.Vector(0, 3, 0)
sumvec = myvec.add(othervec)

Еще одно имеющееся у всех объектов FreeCAD свойство - это его размещение. Каждый объект имеет свойство ДАННЫЕPlacement, которое содержит DataBase (положение) и DataRotation (ориентация) объекта. Это легко манипулировать, например, чтобы переместить наш объект:

box.Placement
box.Placement.Base
box.Placement.Base = sumvec
 
otherpla = FreeCAD.Placement()
box.Placement = otherpla

Теперь вы должны понять пару важных понятий, прежде чем мы продолжим.

top

App и Gui

FreeCAD был разработан так, чтобы его можно было использовать без пользовательского интерфейса, как приложение командной строки. Поэтому почти каждый объект в FreeCAD состоит из двух частей: Object, компонент "геометрии", и ViewObject, его "визуальная" компонента. При работе в режиме командной строки геометрическая часть имеется, но визуальная часть отключена.

Для иллюстрации концепции давайте посмотрим на наш объект куба. Геометрические свойства куба, такие как его размеры, положение и т.д., хранятся в Object. А его визуальные свойства, такие как цвет, толщина линий и т.д., хранятся в ViewObject. Это соответствует вкладкам «Данные» и «Вид» в Редакторе свойств. Доступ к объекту вида осуществляется следующим образом:

vo = box.ViewObject

Теперь вы также можете изменить свойства на вкладке «Вид»:

vo.Transparency = 80
vo.hide()
vo.show()

Когда вы запускаете FreeCAD, консоль Python уже загрузила два базовых модуля: FreeCAD и FreeCADGui(которые также могут быть доступны по их ярлыкам App и Gui). Они содержат все виды общих функций для работы с документами и их объектами. Для иллюстрации нашей концепции, посмотрите, что и FreeCAD, и FreeCADGui содержат атрибут ActiveDocument, который является текущим открытым документом. Однако FreeCAD.ActiveDocument и FreeCADGui.ActiveDocument это не один и тот же объект. Это два компонента документа FreeCAD, и содержат разные атрибуты и методы. Например, FreeCADGui.ActiveDocument содержит ActiveView, это текущий открытый трёхмерный вид.

top

Модули

Истинная сила FreeCAD заключается в его верных модулях. Базовое приложение FreeCAD - это более или менее пустой контейнер. Без своих модулей он может сделать немного больше, чем создавать новые, пустые документы. Каждый модуль добавляет к интерфейсу не только новые верстаки, но и новые команды Python и новые типы объектов. В результате несколько разных и даже полностью несовместимых типов объектов могут сосуществовать в одном документе. Наиболее важные модули в FreeCAD, которые мы рассмотрим в этом руководстве, это: Part, Mesh, Sketcher и Draft.

Модули Sketcher и Draft используют модуль Part для создания и поддержки их геометрии, в то время как модуль Mesh полностью независим и поддерживает собственные объекты. Подробнее об этом ниже.

Вы можете проверить все доступные типы базовых объектов для текущего документа следующим образом:

doc.supportedTypes()

Различные модули FreeCAD не загружаются в консоль Python автоматически. Это нужно для того, чтобы избежать замедленного запуска. Модули загружаются только тогда, когда они вам нужны. Поэтому для исследования того, что, например, находится внутри модуля Part:

import Part
Part.

Но мы поговорим подробнее о модуле Part ниже.

top

Mesh

Сетки (meshes) это весьма простой тип трёхмерных объектов, используемых, например, в Sketchup, Blender и 3D Studio Max. Они состоят из 3 элементов: точек (также называемых вершинами), линий (также называемых ребрами) и граней. Во многих приложениях, включая FreeCAD, грани могут иметь только 3 вершины. Разумеется, ничто не мешает использовать более крупные грани, состоящее из нескольких копланарных треугольников.

Сетки просты, и благодаря простоте их можно иметь миллионами в одном документе. Однако в FreeCAD они имеют меньшее использование, и в основном там, где надо импортировать объекты в форматах сетки (.stl, .obj) из других приложений. Модуль Mesh так же широко использовался в качестве основного тестового модуля в первые месяцы жизни FreeCAD.

Сеточные объекты и объекты FreeCAD - это разные вещи. Вы можете видеть объект FreeCAD как контейнер для объекта Mesh (и, как мы увидим ниже, также для объектов Part). Поэтому чтобы добавить объект сетки в FreeCAD, мы должны сначала создать объект FreeCAD и объект Mesh, а затем добавить объект Mesh в объект FreeCAD:

import Mesh
mymesh = Mesh.createSphere()
mymesh.Facets
mymesh.Points
 
meshobj = doc.addObject("Mesh::Feature", "MyMesh")
meshobj.Mesh = mymesh
doc.recompute()

Это стандартный пример, который использует метод createSphere() для создания сферы, но вы также можете создавать собственные сетки с нуля, определяя их вершины и грани.

Дальнейшее чтение о скриптах обработки сеток...

top

Part

Модуль Part это самый мощный модуль во всём FreeCAD. Он позволяет создавать и управлять объектами граничного представления (BRep). Объект BRep (Boundary Representation) определяется поверхностями, которые ограничивают и определяют внутренний объем. В отличие от сеток, объекты BRep могут иметь широкий спектр компонентов, от плоских граней до очень сложных поверхностей NURBS.

Модуль Part основан на мощной библиотеке OpenCasCade, обеспечивающей широкий спектр сложных операций над этими объектами, таких как логические операции, филетирование, лофты и т. д.

Модуль Part работает так же, как и модуль Mesh: вы создаете объект FreeCAD, объект Part, а затем добавляете объект Part к объекту FreeCAD:

import Part
myshape = Part.makeSphere(10)
myshape.Volume
myshape.Area

shapeobj = doc.addObject("Part::Feature", "MyShape")
shapeobj.Shape = myshape
doc.recompute()

Модуль Part, как и модуль Mesh, имеет ярлык, который автоматически создает объект FreeCAD и добавляет к нему форму, поэтому вы можете сократить последние три строки до:

Part.show(myshape)

Исследуя содержимое myshape, вы заметите много интересных подкомпонентов, таких как Faces, Edges, Vertexes, Solids и Shells, и широкий спектр геометрических операций, таких как cut (вычитание), common (пересечение) или fuse (объединение). Страница Топологические сценарии данных объясняет все это в деталях.

Читать далее про обработку объектов Part в скриптах...

top

Draft

FreeCAD включает в себя много других модулей, таких как Sketcher и Draft, которые также создают объекты Part. Эти модули добавляют дополнительные параметры к созданным объектам или даже реализуют в них совершенно новый способ обработки геометрии Part. Наш приведенный выше пример куба является идеальным примером параметрического объекта. Все, что вам нужно, чтобы определить куб, это указать параметры высоты, ширины и длины. Исходя из этого, объект автоматически рассчитает свою форму Part. FreeCAD позволяет вам создавать такие объекты в Python.

Модуль Draft добавляет двумерные параметрические типы объектов (которые являются объектами Part), такие как линии и круги, а также предоставляет некоторые общие функции, которые работают не только с объектами Draft, но и с любым объектом Part. Чтобы узнать, что доступно, просто сделайте:

import Draft
rec = Draft.makeRectangle(5, 2)
mvec = FreeCAD.Vector(4, 4, 0)
Draft.move(rec, mvec)
Draft.move(box, mvec)

top

Интерфейс

Пользовательский интерфейс FreeCAD сделан с помощью Qt, мощной системs графического интерфейса, отвечающей за рисование и обработку всех элементов управления, меню, панелей инструментов и кнопок вокруг окна трёхмерного просмотра. В Qt есть модуль PySide, через который Python получает доступ к интерфейсам Qt, таким как у FreeCAD. Давайте попробуем поработать с интерфейсом Qt и создать простой диалог:

from PySide import QtGui
QtGui.QMessageBox.information(None, "Apollo program", "Houston, we have a problem")

Обратите внимание, что в появившемся диалоговом окне на панели инструментов есть значок FreeCAD, означающий, что Qt знает, что вызов был отдан из приложения FreeCAD. Можно манипулировать любой частью интерфейса FreeCAD.

Qt - это очень мощная система интерфейса, позволяющая делать очень сложные вещи. Она так же имеет несколько простых в использовании инструментов, таких как Qt Designer, с помощью которых вы можете создавать графические диалоги, а затем добавлять их в интерфейс FreeCAD с помощью нескольких строк кода Python.

Дальнейшее чтение о PySide здесь...

top

Макросы

Теперь, уже хорошо понимая основы, где мы будем хранить наши скрипты Python и как мы собираемся запускать их внутри FreeCAD? Для этого есть простой механизм, называемый Макросы. Макросы - это скрипты Python, которые можно добавлять в панели инструментов и запускать кликом мыши. FreeCAD предоставляет простой текстовый редактор (Макросы → Макрос... → Собрать), где вы можете написать или вставить сценарии. Как только скрипт готов, используйте Инструменты → Настройка... → Макрос для определения ему кнопки, которую можно добавить на панели инструментов.

Теперь вы готовы к более глубокому написанию сценариев FreeCAD. Так вперёд в Центр опытных пользователей!

top